<?php 

class ControllerPaymentWebToPay extends Controller {
    private $error = array(); 

    public function index() {
        $this->load->language('payment/webtopay');

        $this->document->title = $this->language->get('heading_title');
         
        $this->load->model('setting/setting');
            
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
            $this->load->model('setting/setting');
            
            $this->model_setting_setting->editSetting('webtopay', $this->request->post);                
            
            $this->session->data['success'] = $this->language->get('text_success');

            $this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->data['heading_title'] = $this->language->get('heading_title');

        $this->data['text_enabled'] = $this->language->get('text_enabled');
        $this->data['text_disabled'] = $this->language->get('text_disabled');
        $this->data['text_all_zones'] = $this->language->get('text_all_zones');
        $this->data['text_none'] = $this->language->get('text_none');
        $this->data['text_yes'] = $this->language->get('text_yes');
        $this->data['text_no'] = $this->language->get('text_no');
        $this->data['text_successful'] = $this->language->get('text_successful');
        $this->data['text_declined'] = $this->language->get('text_declined');
        $this->data['text_off'] = $this->language->get('text_off');
        
        $this->data['entry_merchant'] = $this->language->get('entry_merchant');
        $this->data['entry_project'] = $this->language->get('entry_project');
        $this->data['entry_sign'] = $this->language->get('entry_sign');
        $this->data['entry_lang'] = $this->language->get('entry_lang');
        $this->data['entry_callback'] = $this->language->get('entry_callback');
        $this->data['entry_test'] = $this->language->get('entry_test');
        $this->data['entry_order_status'] = $this->language->get('entry_order_status');     
        $this->data['entry_geo_zone'] = $this->language->get('entry_geo_zone');
        $this->data['entry_status'] = $this->language->get('entry_status');
        $this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
        
        $this->data['help_callback'] = $this->language->get('help_callback');

        $this->data['button_save'] = $this->language->get('button_save');
        $this->data['button_cancel'] = $this->language->get('button_cancel');

        $this->data['tab_general'] = $this->language->get('tab_general');

        if (!isset($this->error['warning'])) $this->error['warning'] = '';
        $this->data['error_warning'] = $this->error['warning'];
        if (!isset($this->error['project'])) $this->error['project'] = '';
        $this->data['error_project'] = $this->error['project'];
        if (!isset($this->error['sign'])) $this->error['sign'] = '';
        $this->data['error_sign'] = $this->error['sign'];
        if (!isset($this->error['lang'])) $this->error['lang'] = '';
        $this->data['error_lang'] = $this->error['lang'];

        $this->document->breadcrumbs = array();

        $this->document->breadcrumbs[] = array(
            'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token']),
            'text'      => $this->language->get('text_home'),
            'separator' => FALSE
        );

        $this->document->breadcrumbs[] = array(
            'href'      => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
            'text'      => $this->language->get('text_payment'),
            'separator' => ' :: '
        );

        $this->document->breadcrumbs[] = array(
            'href'      => $this->url->link('payment/webtopay', 'token=' . $this->session->data['token'], 'SSL'),
            'text'      => $this->language->get('heading_title'),
            'separator' => ' :: '
        );
                
        $this->data['action'] = $this->url->link('payment/webtopay', 'token=' . $this->session->data['token'], 'SSL');
        
        $this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');
    
        if (isset($this->request->post['webtopay_project'])) {
            $this->data['webtopay_project'] = $this->request->post['webtopay_project'];
        } else {
            $this->data['webtopay_project'] = $this->config->get('webtopay_project');
        }
        
        if (isset($this->request->post['webtopay_sign'])) {
            $this->data['webtopay_sign'] = $this->request->post['webtopay_sign'];
        } else {
            $this->data['webtopay_sign'] = $this->config->get('webtopay_sign');
        }
        
        if (isset($this->request->post['webtopay_lang'])) {
            $this->data['webtopay_lang'] = $this->request->post['webtopay_lang'];
        } else {
            $this->data['webtopay_lang'] = $this->config->get('webtopay_lang');
        }
        
        $this->data['callback'] = $this->url->link('payment/webtopay/callback');

        if (isset($this->request->post['webtopay_test'])) {
            $this->data['webtopay_test'] = $this->request->post['webtopay_test'];
        } else {
            $this->data['webtopay_test'] = $this->config->get('webtopay_test');
        }
        
        if (isset($this->request->post['webtopay_order_status_id'])) {
            $this->data['webtopay_order_status_id'] = $this->request->post['webtopay_order_status_id'];
        } else {
            $this->data['webtopay_order_status_id'] = $this->config->get('webtopay_order_status_id'); 
        } 
        
        $this->load->model('localisation/order_status');
        
        $this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
        
        if (isset($this->request->post['webtopay_geo_zone_id'])) {
            $this->data['webtopay_geo_zone_id'] = $this->request->post['webtopay_geo_zone_id'];
        } else {
            $this->data['webtopay_geo_zone_id'] = $this->config->get('webtopay_geo_zone_id'); 
        } 

        $this->load->model('localisation/geo_zone');
                                        
        $this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
        
        if (isset($this->request->post['webtopay_status'])) {
            $this->data['webtopay_status'] = $this->request->post['webtopay_status'];
        } else {
            $this->data['webtopay_status'] = $this->config->get('webtopay_status');
        }
        
        if (isset($this->request->post['webtopay_sort_order'])) {
            $this->data['webtopay_sort_order'] = $this->request->post['webtopay_sort_order'];
        } else {
            $this->data['webtopay_sort_order'] = $this->config->get('webtopay_sort_order');
        }
        /*
        $this->id       = 'content';
        $this->template = 'payment/webtopay.tpl';
        $this->layout   = 'common/layout';
        
        $this->render();*/
        
        $this->template = 'payment/webtopay.tpl';
        $this->children = array(
            'common/header',    
            'common/footer' 
        );
        
        $this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
    
    }

    private function validate() {
        if (!$this->user->hasPermission('modify', 'payment/webtopay')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }
        
        if (!@$this->request->post['webtopay_project']) {
            $this->error['project'] = $this->language->get('error_project');
        }
        
        if (!@$this->request->post['webtopay_sign']) {
            $this->error['sign'] = $this->language->get('error_sign');
        }
        
        if (!@$this->request->post['webtopay_lang']) {
            $this->error['lang'] = $this->language->get('error_lang');
        }
                
        if (!$this->error) {
            return TRUE;
        } else {
            return FALSE;
        }   
    }
}
?>
